#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <net/if.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"


char ip[255], message[255], ip_addy[255];
gpointer ip_entry, ip_combo, message_box, chat_entry;
int reply, msg_len, user_len;
gchar *out_ip;
GtkWidget *main_app_window;

char
*get_prefs(char pref_name[255])
{
 char dir[255], newdir[255], temp[255] = "", data[255] = "";
 char ch[255] = "";
 int i, go = 0, mdir = 0;
 FILE *fp;

 strcpy(dir, getenv("HOME"));
 strcat(dir, "/.spat/spatrc");
 fp = fopen(dir, "r");

 if (!fp)
 {
  printf("Config not found.\nAttempting to Create new\n");
  strcpy(newdir, getenv("HOME"));
  strcat(newdir, "/.spat/");
  mdir = mkdir(newdir, 0700);
  if (mdir == 0)
  {
   printf("Created ~/.spat\n");
  }
  fp = fopen(dir, "w");
  if (!fp)
  {
   printf("Failure to create config. ARG!\n");
   exit(0);
  }
  fprintf(fp, "spatrc -> interface: eth0\n");
  fclose(fp);
  printf("Wrote ~/.spat/spatrc\n");
  fp = fopen(dir, "r");
  if (!fp)
  {
   printf("OOOOOOUCH!\n");
  }
 }

 i = 0;
 while(feof(fp) != 1)
 {
  ch[i] = fgetc(fp);
  if (ch[i] == ' ') 
  {
   i = -1;
  }
  if ((ch[i] == ':') && (ch[i] != ' '))
  {
   if (!strcmp(pref_name, ch))
   {
    bcopy(temp, ch, 255);
    go = 1;
    i = -1;
   }
   i = -1;
  }
  if ((ch[i] == '\n') && (go == 0) && (ch[i] != ' '))
  {
   i = -1;
   bcopy(temp, ch, 255);
  }
  if ((ch[i] == '\n') && (go == 1) && (ch[i] != ' '))
  {
   ch[i] = '\0';
   strcpy(data, ch);
   bcopy(temp, ch, 255);
   go = 0;
   i = -1;
  }
  i++;
 }
 fclose(fp);
 return data;	 
}
 
char 
*get_ifinfo(char type[255])
{
 struct ifreq ifi;
 int sock, iftype = 0;
 char *bcast_addy, *interface = "eth0";

 sock = socket(AF_INET, SOCK_DGRAM, 0);
 if (sock < 0)
 {
  printf("socket error\n");
  exit(0);
 }
 
 interface = get_prefs("interface:");
 
 memset(&ifi, 0, sizeof(ifi));
 ifi.ifr_addr.sa_family = AF_INET;
 strncpy(ifi.ifr_name, interface, sizeof(ifi.ifr_name));

 if (!strcmp(type, "addy"))
 {
  iftype = SIOCGIFADDR;
 }
 if (!strcmp(type, "bcast"))
 {
  iftype = SIOCGIFBRDADDR;
 }
 
//  SIOCGIFADDR SIOCGIFBRDADDR
 
 if ( ioctl(sock, iftype, (caddr_t) &ifi) < 0)
 {
  printf("ioctl error %s\n", type);
  exit(0);
 }


 printf("Using %s: %s\n", type, inet_ntoa (((struct sockaddr_in *)
		&ifi.ifr_broadaddr)->sin_addr));

 bcast_addy = inet_ntoa (((struct sockaddr_in *) &ifi.ifr_broadaddr)->sin_addr);

 return bcast_addy;
}
 
char
*strip_colons (char temp_data[255])
{
 int i = 0, len;
 
 len = strlen(temp_data);
 
 while(i != len)
 {
  if (temp_data[i] == ':')
  {
   temp_data[i] = '|';
  }
  i++;
 }
 return temp_data;
}

void
send_broadcast(void)
{
  int server_sockfd, client_sockfd;
  int server_len, broadcast_len;
  struct sockaddr_in server_address;
  struct sockaddr_in broadcast_address;
  static int so_broadcast = TRUE;
  char myip_addy[255], mybcast_addy[255];

 strcpy(myip_addy, get_ifinfo("addy"));
 strcpy(mybcast_addy, get_ifinfo("bcast"));

 g_print("-> Get user list\n");

// strcpy(message, strip_colons(message));

 server_address.sin_family = AF_INET;
 server_address.sin_addr.s_addr = inet_addr(ip_addy);
 server_len = sizeof(server_address);

 broadcast_address.sin_family = AF_INET;
 broadcast_address.sin_addr.s_addr = inet_addr(mybcast_addy);
 broadcast_address.sin_port = htons(4001);
 broadcast_len = sizeof(broadcast_address);

 server_sockfd = socket(AF_INET, SOCK_DGRAM, 0);


 client_sockfd = setsockopt(server_sockfd, SOL_SOCKET,
                                SO_BROADCAST,
                                &so_broadcast,
                                sizeof so_broadcast);
 client_sockfd = bind(server_sockfd, (struct sockaddr *)&server_address,
 		 server_len);
 
 client_sockfd = sendto(server_sockfd, "-who_is_on-", 255, 0,
                                        (struct sockaddr *)&broadcast_address,
                                        broadcast_len);
}

void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 exit(0);
}

void
get_message (char data1[255], char data2[255], char data3[255], char data4[255])
{
 strcpy(ip, data1);
 strcpy(message, data2);
}

void
on_button2_clicked                     (GtkButton       *button,
		                        gpointer         user_data)
{
  GtkWidget *msg_too_long, *name_too_long;
  char message[255], tiny_message[255], temp_loginid[255], myip_addy[255], mybcast_addy[255];
  int server_sockfd, client_sockfd;
  int server_len, broadcast_len;
  struct sockaddr_in server_address;
  struct sockaddr_in broadcast_address;
  static int so_broadcast = TRUE;
  gchar *out_message;

  
 out_message = gtk_editable_get_chars( GTK_TEXT(message_box), 0, -1);
 out_ip = gtk_entry_get_text( GTK_ENTRY(ip_combo));  
 g_print("-> %s\n", out_ip);

 strncpy(tiny_message, out_message, 150);
 msg_len = strlen(out_message);
 user_len = strlen(out_ip);
 printf("->debug\n");
 if (user_len >= 12)
 {
  printf("USER NAME TOO BIG\n");
  gtk_widget_hide(main_app_window);
  name_too_long = create_name_too_long ();
  gtk_widget_show (name_too_long);
 }  
 
 if (msg_len >= 150)
 {
  printf("MSG TOO BIG\n");
  gtk_widget_hide(main_app_window);
  msg_too_long = create_msg_too_long ();
  gtk_widget_show (msg_too_long);
 }
  
 if ((msg_len <= 149) && (user_len <= 11))
 { 
 strcpy(myip_addy, get_ifinfo("addy")); 
 strcpy(mybcast_addy, get_ifinfo("bcast"));

 strcpy(message, strip_colons(out_ip));
 strcat(message, ":");
 strcat(message, strip_colons(tiny_message));
 strcat(message, ":");
 cuserid(temp_loginid);
 strcat(message, temp_loginid);
 strcat(message, ":");
 strcat(message, "0"); 

 server_address.sin_family = AF_INET;
 server_address.sin_addr.s_addr = inet_addr(myip_addy);
 server_len = sizeof(server_address);

 broadcast_address.sin_family = AF_INET;
 broadcast_address.sin_addr.s_addr = inet_addr(mybcast_addy);
 broadcast_address.sin_port = htons(4001);
 broadcast_len = sizeof(broadcast_address);

 server_sockfd = socket(AF_INET, SOCK_DGRAM, 0);

 client_sockfd = setsockopt(server_sockfd, SOL_SOCKET,
                                SO_BROADCAST,
                                &so_broadcast,
                                sizeof so_broadcast);

 client_sockfd = bind(server_sockfd, (struct sockaddr *)&server_address,
                                                        server_len);
 client_sockfd = sendto(server_sockfd, message, 255, 0,
                                        (struct sockaddr *)&broadcast_address,
					broadcast_len);
 exit(0);
 }
}
 

void
on_dialog1_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
 FILE *fp;
 char temp[255];
 char user_list[255];
 int i = 0;


 send_broadcast();
 
 ip_entry = user_data;

 strcpy(user_list, getenv("HOME"));
 strcat(user_list, "/.spat/users");
 
 g_print("Parsing %s\n", user_list);
 fp = fopen(user_list, "r");
 if (!fp)
 {
  g_print("File Not Found\n");
  printf("Attempting to create User List\n");
  fp = fopen(user_list, "w");
  if (!fp)
  {
   printf("Failure to create User List! ARG!\n");
   exit(1);
  }
  fprintf(fp, "Welcome_to_Spat!\n");
  fclose(fp);
  printf("Wrote ~/.spat/users\n");
  fp = fopen(user_list, "r");
 }
 while(feof(fp) != 1)
 {
   fscanf(fp, "%s", temp);
   if (feof(fp) != 1)
   {
    g_print("	-> %s\n", temp);
    gnome_entry_append_history( GNOME_ENTRY(ip_entry), 0, temp);
    i++;
   }
 }
 fclose(fp); 
}



void
on_dialog1_show2                       (GtkWidget       *widget,
                                        gpointer         user_data)
{
 message_box = user_data;
 ip_combo = gnome_entry_gtk_entry ( GNOME_ENTRY (ip_entry));

}


void
on_refresh_list1_activate              (GtkMenuItem     *menuitem,
		                        gpointer         user_data)

{
 FILE *fp;
 char temp[255];
 char user_list[255];
 int i = 0;


 send_broadcast();

 gnome_entry_set_history_id( GNOME_ENTRY(ip_combo), NULL);

 strcpy(user_list, getenv("HOME"));
 strcat(user_list, "/.spat/users");

 g_print("Parsing %s\n", user_list);
 fp = fopen(user_list, "r");
 if (!fp)
 {
  g_print("File Not Found\n");
  exit(0);
 }
 while(feof(fp) != 1)
 {
   fscanf(fp, "%s", temp);
   if (feof(fp) != 1)
   {
    g_print("   -> %s\n", temp);
    gnome_entry_append_history( GNOME_ENTRY(ip_entry), 0, temp);
    i++;
   }
 }
 fclose(fp); 
}


gint
on_dialog1_close                       (GnomeDialog     *gnomedialog,
                                        gpointer         user_data)
{
 if ((msg_len <= 149) && (user_len <= 11))
 {
  exit(0);
 }
 return 0;
}


void
on_dialog1_show3                       (GtkWidget       *widget,
                                        gpointer         user_data)
{
  
 main_app_window = user_data;

 if (strcmp(ip, ""))
 {
  g_print("setting reply to '%s'\n", ip);
  gtk_entry_set_text( GTK_ENTRY(ip_combo), ip);
 }
   
}

void
on_text1_activate                      (GtkEditable     *editable,
		                        gpointer         user_data)
{
 on_button2_clicked(NULL, NULL);
}



void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 exit(0);
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 GtkWidget *about1;

 
 about1 = create_about1 ();
 gtk_widget_show (about1);
  
}




void
on_send1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 on_button2_clicked(NULL, NULL);
}


void
on_msg_too_long_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
 exit(0);
}



void
on_name_too_long_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
 exit(0);
}


gint
on_msg_too_long_close                  (GnomeDialog     *gnomedialog,
                                        gpointer         user_data)
{
 exit(0);
}


gint
on_name_too_long_close                 (GnomeDialog     *gnomedialog,
                                        gpointer         user_data)
{
 exit(0);
}

void
on_entry2_activate                     (GtkEditable     *editable,
                                        gpointer         user_data)
{
// extern gpointer chat_entry;

// chat_entry = user_data;
 on_button2_clicked(NULL, NULL); 
}


void
on_button6_clicked                     (GtkButton       *button,   
                                        gpointer         user_data)
{

}

void
on_chat_window_show                    (GtkWidget       *widget,
                                        gpointer         user_data)
{
 extern gpointer chat_entry;

 chat_entry = user_data;


}
