#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <unistd.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "prefs.h"
#include "net.h"

gpointer *text_box;
GtkWidget *frame, *applet;
GdkBitmap *mask;
GtkStyle *style;

char
*get_time(void)
{
 char string[255];
 struct tm *t;
 time_t tt;

 tt = time(NULL);
 t  = localtime(&tt);
 strftime(string, 9, "%H:%M:%S", t);

 return string;
}

char
*strip_colons (char temp_data[255])
{
 /* 
  *   
  * Strip our delimiter ( | ) and replace it with ( : )
  * so our message looks like it did when the user sent it
  *       
  */

 int i = 0, len;

 len = strlen(temp_data);

 while(i != len)
 {
  if (temp_data[i] == '|')
  {
   temp_data[i] = ':';
  }
 i++;
 }
 return temp_data;
}

void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 /* 
  * Close button was click, so hide the window but go back to listening
  */

 gtk_widget_hide (user_data);
}


void
on_dialog1_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
 /*
  * Propagate the POPUP window's label and text box.
  */
 extern GtkWidget *from_label, *text1;
 extern char message[255];
 extern char remote_login[255];
 char temp[255];

 strcpy(temp, remote_login);
 strcat(temp, "@");
 strcat(temp, get_time());
 gtk_label_set_text( from_label, temp);
 gtk_text_insert( text1, NULL, NULL, NULL, strip_colons(message), -1);
}

/* Reply Button */
void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
/*
 * If the reply was hit, then exec spat with the username to reply to 
 * as an argument... i.e. /usr/local/bin/spatd jess
 */
 extern char remote_login[255];
 char command[255];

 if (!strcmp(remote_login, " all"))
 {
  //exit(0);
 }
 strcpy(command, "/usr/local/bin/spat ");
 strcat(command, remote_login);

 strcat(command, " &");
 gtk_widget_hide(user_data);
 printf("loading: %s\n", command);
 system(command);
}


gboolean
on_dialog1_client_event                (GtkWidget       *widget,
                                        GdkEventClient  *event,
                                        gpointer         user_data)
{

  return FALSE;
}

void
on_ok_button_clicked                   (GtkButton       *button,
		                                        gpointer         user_data)
{
 extern GtkWidget *properties_window;
 gchar *away_message = "";
 char dir[255], temp_message[255] = "";
 int length;
 FILE *fp;

 strcpy(dir, getenv("HOME"));
 strcat(dir, "/.spat/away");
 
 length = gtk_text_get_length(GTK_TEXT(user_data));
 away_message = gtk_editable_get_chars( GTK_TEXT(user_data), 0, length);

 strcpy(temp_message, away_message);
 fp = fopen(dir, "w+");
 fprintf(fp, "%s", temp_message);
 fclose(fp);
 gtk_widget_hide(properties_window);
}


void
on_cancel_button_clicked               (GtkButton       *button,
		                                        gpointer         user_data)
{

 gtk_widget_hide(user_data);

}

void
properties_callback()
{
 GtkWidget *properties;
 extern GtkWidget *away_checkbutton, *away_mesg_box;
 char dir[255], erase[255] = "", *toggle;
 int i;
 int length;
 FILE *fp;
 extern char message[255];

 strcpy(dir, getenv("HOME"));
 strcat(dir, "/.spat/away");

 fp = fopen(dir, "r");
 if (!fp)
 {
  fp = fopen(dir, "w+");
  fprintf(fp, "I am away.\nYour message has been logged and\nI will respond to you very soon");
  fclose(fp);
  fp = fopen(dir, "r");
 }

 for (i = 0; feof(fp) != 1; i++)
 {
  message[i] = fgetc(fp);
 }
 message[i - 1] = '\0'; 
 fclose(fp);

 length = strlen(message);
 properties = create_properties();
 gtk_widget_show(properties);

 gtk_text_insert(away_mesg_box, NULL, NULL, NULL, message, length);

 toggle = get_prefs("away:");
 if (!strcmp(toggle, "yes"))
 {
  gtk_toggle_button_set_active(away_checkbutton, TRUE); 
 }
 if (!strcmp(toggle, "no"))
 {
  gtk_toggle_button_set_active(away_checkbutton, FALSE);
 }
 bcopy(erase, message, 255);
}

void
on_away_checkbutton_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
 extern GtkWidget *away_checkbutton;

 if (GTK_TOGGLE_BUTTON(away_checkbutton) -> active )
 {
  set_prefs("away:", "yes");
  show_away();
 }
 else
 {
  set_prefs("away:", "no");
  show_back();
 }
 
}

void
on_away_log_show                       (GtkWidget       *widget,
                                        gpointer         user_data)
{
 char ch[65535] = "", dir[255], erase[255] = "";
 int i;
 FILE *fp;

 bcopy(erase, ch, 255);
 
 strcpy(dir, getenv("HOME"));
 strcat(dir, "/.spat/away_log");
 fp = fopen(dir, "r");
 if (!fp)
 {
  fp = fopen(dir, "w+");
  fclose(fp);
  fp = fopen(dir, "r");
 }
 
 for (i = 0; feof(fp) != 1; i++)
 {
  ch[i] = fgetc(fp);
 }

 gtk_text_insert(user_data, NULL, NULL, NULL, ch, -1);
 
}

void
view_away_log()
{
 GtkWidget *away_log;
	
 away_log = create_away_log();
 gtk_widget_show(away_log);
 
}

void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_hide(user_data);
}

void
on_button9_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 char dir[255], *away;	
 FILE *fp;
 extern int away_count;
 extern GtkWidget *frame;
/*
 * This purges the current away log
 */
 
 strcpy(dir, getenv("HOME"));
 strcat(dir, "/.spat/away_log");
 
 fp = fopen(dir, "w");
 fclose(fp);

 gtk_widget_hide(user_data);

 away = get_prefs("away:");
 gtk_frame_set_label(frame, "s!");
 away_count = 0;
}

void
on_button10_clicked                     (GtkButton       *button,
		                         gpointer         user_data)
{
 system("spat &");
}

void
on_entry2_activate                     (GtkEditable     *editable,
                                        gpointer         user_data)
{
 extern GtkWidget *entry2;
 gchar *out_message;
 extern char mygroup[255];

 out_message = gtk_entry_get_text( GTK_ENTRY(user_data));
 send_spat("group", out_message, mygroup);
 gtk_entry_set_text( GTK_ENTRY(entry2), "");
}

void
on_button6_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 extern GtkWidget *chat_window;
 extern int chatmode;
 extern char mygroup[255];
 char user_name[255], bye_mesg[255];

 gtk_widget_hide(chat_window);

 cuserid(user_name);
 strcpy(bye_mesg, "** ");
 strcat(bye_mesg, user_name);
 strcat(bye_mesg, " has left this channel");
 send_spat("exit", bye_mesg, mygroup);
 strcpy(mygroup, " ");
 send_spat("entrance", "this", mygroup);
 chatmode = 0;
}

void
on_join_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
 int temp = 0, textlen;
 extern GtkWidget *spinbutton1, *clist1, *label1, *text2;
 extern char mygroup[255];
 char enter_message[255], user_name[255], this_label[255], bye_mesg[255];

 cuserid(user_name);
 strcpy(bye_mesg, "** ");
 strcat(bye_mesg, user_name);
 strcat(bye_mesg, " has left this channel");
 send_spat("exit", bye_mesg, mygroup); 

 gtk_spin_button_update ( GTK_SPIN_BUTTON(spinbutton1) );
 temp =  gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON(spinbutton1) );
 gcvt(temp, 100, mygroup);

 /* The next four lines clear the text box */
 gtk_text_set_point( GTK_TEXT(text2), 1);
 textlen = gtk_text_get_length( GTK_TEXT(text2));
 gtk_text_forward_delete( GTK_TEXT(text2), (textlen-1));
 gtk_text_set_point( GTK_TEXT(text2), 1);

 strcpy(enter_message, "** ");
 strcat(enter_message, user_name);
 strcat(enter_message, " has joined this channel!");
 gtk_clist_clear ( (GtkCList*) clist1);
 send_spat("entrance", enter_message, mygroup);
 strcpy(this_label, "Users in #");
 strcat(this_label, mygroup);
 gtk_label_set_text(label1, this_label);
}

void
do_chat()
{
 GtkWidget *chat_window;
 extern int chatmode;
 
  if (chatmode != 1)
  {
   chat_window = create_chat_window();
   chatmode = 1;
   gtk_widget_show (chat_window);
  }
}

void
on_spinbutton1_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
 int temp = 0;
 extern GtkWidget *spinbutton1, *clist1, *label1;
 extern char mygroup[255];
 char enter_message[255], user_name[255], this_label[255], bye_mesg[255];

 cuserid(user_name);
 strcpy(bye_mesg, "** ");
 strcat(bye_mesg, user_name);
 strcat(bye_mesg, " has left this channel");
 send_spat("exit", bye_mesg, mygroup);

 gtk_spin_button_update ( GTK_SPIN_BUTTON(spinbutton1) );
 temp =  gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON(spinbutton1) );
 gcvt(temp, 100, mygroup);

 strcpy(enter_message, "** ");
 strcat(enter_message, user_name);
 strcat(enter_message, " has joined this channel!");
 gtk_clist_clear ( (GtkCList*) clist1);
 send_spat("entrance", enter_message, mygroup);
 strcpy(this_label, "Users in #");
 strcat(this_label, mygroup);
 gtk_label_set_text(label1, this_label);
}

void
on_chat_window_close                   (GtkWidget       *widget,
                                        gpointer         user_data)
{
 extern GtkWidget *chat_window;
 extern int chatmode;
 extern char mygroup[255];
 char user_name[255], bye_mesg[255];

 gtk_widget_hide(chat_window);

 cuserid(user_name);
 strcpy(bye_mesg, "** ");
 strcat(bye_mesg, user_name);
 strcat(bye_mesg, " has left this channel");
 send_spat("exit", bye_mesg, mygroup);
 strcpy(mygroup, " ");
 send_spat("entrance", "this", mygroup);
 chatmode = 0;
}
