#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <net/if.h>

#include "net.h"
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "prefs.h"

char
*modify_colons (char temp_data[255])
{
 /*
  * Strip our message delimiter ( : ) and replace it with ( | )
  */
 int i = 0, len;

 len = strlen(temp_data);

 while(i != len)
 {
  if (temp_data[i] == ':')
  {
   temp_data[i] = '|';
  }
  i++;
 }
 return temp_data;
}

void
send_spat(char *user_name, char *send_message, char *temp_group)
{
  char message[255], tiny_message[255], temp_loginid[255], myip_addy[255], mybcast_addy[255];
  int server_sockfd, client_sockfd;
  int server_len, broadcast_len, msg_len, user_len;
  struct sockaddr_in server_address;
  struct sockaddr_in broadcast_address;
  static int so_broadcast = TRUE;

 strncpy(tiny_message, send_message, 150);
 msg_len = strlen(send_message);
 user_len = strlen(user_name);
 if (user_len >= 12)
 {
  printf("USER NAME TOO BIG\n");
 }

 if (msg_len >= 150)
 {
  printf("MSG TOO BIG\n");
 }

 if ((msg_len <= 149) && (user_len <= 11))
 {
 strcpy(myip_addy, get_ifinfo("addy"));
 strcpy(mybcast_addy, get_ifinfo("bcast"));

 strcpy(message, modify_colons(user_name));
 strcat(message, ":");
 strcat(message, modify_colons(tiny_message));
 strcat(message, ":");
 cuserid(temp_loginid);
 strcat(message, temp_loginid);
 strcat(message, ":");
 strcat(message, temp_group);

 server_address.sin_family = AF_INET;
 server_address.sin_addr.s_addr = inet_addr(myip_addy);
 server_len = sizeof(server_address);

 broadcast_address.sin_family = AF_INET;
 broadcast_address.sin_addr.s_addr = inet_addr(mybcast_addy);
 broadcast_address.sin_port = htons(4001);
 broadcast_len = sizeof(broadcast_address);

 server_sockfd = socket(AF_INET, SOCK_DGRAM, 0);

 client_sockfd = setsockopt(server_sockfd, SOL_SOCKET,
                                SO_BROADCAST,
                                &so_broadcast,
                                sizeof so_broadcast);

 client_sockfd = bind(server_sockfd, (struct sockaddr *)&server_address,
                                                        server_len);
 client_sockfd = sendto(server_sockfd, message, 255, 0,
                                        (struct sockaddr *)&broadcast_address,
                                        broadcast_len);
 }
}

void
get_user_list()
{
 FILE *fp;
 char temp[255];
 char user_list[255];
 int i = 0;

 send_broadcast("list");

 strcpy(user_list, getenv("HOME"));
 strcat(user_list, "/.spat/users");

 g_print("Parsing %s\n", user_list);
 fp = fopen(user_list, "r");
 if (!fp)
 {
  g_print("File Not Found\n");
  printf("Attempting to create User List\n");
  fp = fopen(user_list, "w");
  if (!fp)
  {
   printf("Failure to create User List! ARG!\n");
   exit(1);
  }
  fprintf(fp, "Welcome_to_Spat!\n");
  fclose(fp);
  printf("Wrote ~/.spat/users\n");
  fp = fopen(user_list, "r");
 }
 while(feof(fp) != 1)
 {
   fscanf(fp, "%s", temp);
   if (feof(fp) != 1)
   {
    g_print("   -> %s\n", temp);
    i++;
   }
 }
 fclose(fp);
}

int
send_broadcast(char type[255])
{
  char message[255], temp_login[255], myip_addy[255], mybcast_addy[255];
  int server_sockfd, client_sockfd;
  int server_len, broadcast_len;
  struct sockaddr_in server_address;
  struct sockaddr_in broadcast_address;
  static int so_broadcast = TRUE;
  extern char mygroup[255];

/* Send a list update request to all clients */

 cuserid(temp_login);
 if (!strcmp(type, "list"))
 {
  strcpy(message, "list:");
  strcat(message, temp_login);
  strcat(message, ":server:");
  strcat(message, mygroup);
 }
 if (!strcmp(type, "group"))
 {
  strcpy(message, "grouplist:this:");
  strcat(message, temp_login);
  strcat(message, ":");
  strcat(message, mygroup);
 }



 strcpy(myip_addy, get_ifinfo("addy"));
 strcpy(mybcast_addy, get_ifinfo("bcast"));

 server_address.sin_family = AF_INET;
 server_address.sin_addr.s_addr = inet_addr(myip_addy);
 server_len = sizeof(server_address);

 broadcast_address.sin_family = AF_INET;
 broadcast_address.sin_addr.s_addr = inet_addr(mybcast_addy);
 broadcast_address.sin_port = htons(4001);
 broadcast_len = sizeof(broadcast_address);

 server_sockfd = socket(AF_INET, SOCK_DGRAM, 0);


 client_sockfd = setsockopt(server_sockfd, SOL_SOCKET,
                                SO_BROADCAST,
                                &so_broadcast,
                                sizeof so_broadcast);
 client_sockfd = bind(server_sockfd, (struct sockaddr *)&server_address,
                                                        server_len);
 client_sockfd = sendto(server_sockfd, message, 255, 0,
                                       (struct sockaddr *)&broadcast_address,
                                        broadcast_len);

 return 0;
}

void
away_message(char user_name[255])
{
 char myip_addy[255], mybcast_addy[255], message[255];
 int server_sockfd, client_sockfd;
 int server_len, broadcast_len;
 struct sockaddr_in server_address;
 struct sockaddr_in broadcast_address;
 static int so_broadcast = TRUE;
 char out_message[255] = "", msg_from[255], dir[255];
 int i = 0, length;
 FILE *fp;

 strcpy(myip_addy, get_ifinfo("addy"));
 strcpy(mybcast_addy, get_ifinfo("bcast"));

 strcpy(dir, getenv("HOME"));
 strcat(dir, "/.spat/away");


 fp = fopen(dir, "r");
 if (!fp)
 {
  fp = fopen(dir, "w+");
  fprintf(fp, "I am away.\nYour message has been logged and\nI will respond to you very soon");
  fclose(fp);
  fp = fopen(dir, "r");
 }

 i = 0;
 for(i = 0; feof(fp) != 1; i++)
 {
  out_message[i] = fgetc(fp);
 }
 out_message[i] = '\0';

 length = strlen(out_message);
 if (length >= 158)
 {
  printf("Messge too long!!!!!!\n");
 }
if (length <= 158)               /* Build the away message */
{
 cuserid(msg_from);
 strcpy(message, user_name);
 strcat(message, ":");
 strcat(message, out_message);
 strcat(message, ":");
 strcat(message, msg_from);
 strcat(message, ":");
 strcat(message, "0");

 printf("Preparing to send\n");
 server_address.sin_family = AF_INET;
 server_address.sin_addr.s_addr = inet_addr(myip_addy);
 server_len = sizeof(server_address);

 broadcast_address.sin_family = AF_INET;
 broadcast_address.sin_addr.s_addr = inet_addr(mybcast_addy);
 broadcast_address.sin_port = htons(4001);
 broadcast_len = sizeof(broadcast_address);

 server_sockfd = socket(AF_INET, SOCK_DGRAM, 0);

 client_sockfd = setsockopt(server_sockfd, SOL_SOCKET,
                                SO_BROADCAST,
                                &so_broadcast,
                                sizeof so_broadcast);

 client_sockfd = bind(server_sockfd, (struct sockaddr *)&server_address,
                                                        server_len);
 client_sockfd = sendto(server_sockfd, message, 255, 0,
                                        (struct sockaddr*)&broadcast_address,
                                        broadcast_len);
 printf("Sent ->%s\n", message);
 }
}

